-- ====================================================================================================================
-- =	KvChatDistance - Text effects by distance to source unit
-- =	Copyright (c) Kvalyr - 2021 - All Rights Reserved
-- ====================================================================================================================
local strsplit = _G["strsplit"]
local C_Timer = _G["C_Timer"]
local GetMessageTypeColor = _G["GetMessageTypeColor"]
local UnitInParty = _G["UnitInParty"]
local UnitInRaid = _G["UnitInRaid"]
local UnitName = _G["UnitName"]
-- ====================================================================================================================
-- Debugging
local KLib = _G["KLib"]
if not KLib then
    KLib = {Con = function() end, Warn = function() end, Print = print} -- No-Op if KLib not available
end
-- ====================================================================================================================

KvChatDistance.position = {}

-- --------------------------------------------------------------------------------------------------------------------
-- Triangulation
-- --------------------------------------------------------
-- TODO

-- --------------------------------------------------------------------------------------------------------------------
-- Ticker
-- --------------------------------------------------------
function KvChatDistance.position.TickerFunc()
    local settings = KvChatDistance:GetSettings()
    if not settings.positionBroadcastEnabled then return end

    KvChatDistance.position:GetCurrent()

    KvChatDistance.position:ForceShow(settings.hideNameplatesDuringTrick)
    -- C_Timer.After(settings.nameplateTickerHideDelay, function() KvChatDistance.position:Hide() end)
end

-- --------------------------------------------------------------------------------------------------------------------
-- Broadcast
-- --------------------------------------------------------

function KvChatDistance.position:GetCurrent(unitID)
    if not unitID then unitID = "player" end
    local posY, posX, posZ, instanceID = UnitPosition(unitID)
end


function KvChatDistance.position:StartTicker()
    local self = KvChatDistance
    -- self:Debug("StartTicker")
    local settings = self:GetSettings()

    self.position.TickerFunc()

    local ticker = C_Timer.NewTicker(settings.nameplateTickerInterval or 30, self.position.TickerFunc)
    self.position.ticker = ticker
end

function KvChatDistance.position:StopTicker()
    local self = KvChatDistance
    if not self.position.ticker then return end
    self.position:Hide()
    self.position.ticker:Cancel()
end

function KvChatDistance.position:ResetTicker()
    local self = KvChatDistance
    self.position:StopTicker()
    self.position:StartTicker()
end